function ActivateHotKey: boolean;
begin
KeyID:=GlobalAddAtom('Lexx');
d1:=GlobalAddAtom('d1');
d2:=GlobalAddAtom('d2');
d3:=GlobalAddAtom('d3');
d4:=GlobalAddAtom('d4');

Result:=RegisterHotKey(hWindow,KeyID,MOD_CONTROL or MOD_SHIFT or MOD_ALT,WORD('D'));
Result:=RegisterHotKey(hWindow,D1,MOD_WIN,WORD('1'));
Result:=RegisterHotKey(hWindow,D2,MOD_WIN,WORD('2'));
Result:=RegisterHotKey(hWindow,D3,MOD_WIN,WORD('3'));
Result:=RegisterHotKey(hWindow,D4,MOD_WIN,WORD('4'));
end;

procedure DeactivateHotKey;
begin
UnRegisterHotKey(hWindow,KeyID);
UnRegisterHotKey(hWindow,D1);
UnRegisterHotKey(hWindow,D2);
UnRegisterHotKey(hWindow,D3);
UnRegisterHotKey(hWindow,D4);
GlobalDeleteAtom(KeyID);
end;


function WindowProc(WND: HWND; MSG, wParam, LParam: Cardinal):LongInt; stdcall;
begin
Result:=0;
case MSG of
WM_DESTROY:
begin
RestoreAll;
DeactivateHotKey;
PostQuitMessage(0);
Exit;
end;

WM_HOTKEY:
begin
if HiWord(lParam)=Word('D') then
begin
DialogBox(hInstance,'D_SWITCH',hWindow,@DlgProc);
end;

if HiWord(lParam)=Word('1') then
begin
PrevDsk:=CurrentDsk;
CurrentDsk:=0;
SwitchDesktops;
end;

if HiWord(lParam)=Word('2') then
begin
PrevDsk:=CurrentDsk;
CurrentDsk:=1;
SwitchDesktops;
end;

if HiWord(lParam)=Word('3') then
begin
PrevDsk:=CurrentDsk;
CurrentDsk:=2;
SwitchDesktops;
end;

if HiWord(lParam)=Word('4') then
begin
PrevDsk:=CurrentDsk;
CurrentDsk:=3;
SwitchDesktops;
end;
end; //WM_HOTKEY
end;// case

Result:=DefWindowProc(Wnd,Msg,wParam,lParam);
end;

procedure RegisterWNDClass;
begin
with _WndClass do
begin
cbSize:=SizeOf(_WndClass);
lpfnWndProc:=@WindowProc;
cbClsExtra:=0;
cbWndExtra:=0;
hInstance:=hInstance;
lpszClassName:=PChar(_4);
end;
if RegisterClassEx(_WndClass)=0 then
begin
MessageBox(0,Pchar(_2),PChar(_0),MB_OK or MB_ICONERROR);
Halt(1);
end;
end;

procedure WndCreate;
begin
hWindow:=CreateWindow(PChar(_4),nil,0,
0,0,0,0,0,0,hInstance,nil);
if hWindow=0 then
begin
MessageBox(0,PChar(3),PChar(0),MB_OK or MB_ICONERROR);
Halt(2);
end;
if not ActivateHotKey then
MessageBox(hWindow,PChar(_6),PChar(_0),MB_OK or MB_ICONERROR);
end;
